/*
# C-Code for binary search
# (c) 2011 Jens Oehlschägel
# Licence: GPL2
# Provided 'as is', use at your own risk
# Created: 2011-12-11
# Last changed:  2011-12-11
*/

#include "bsearch.h"

IndexT integer64_bsearch_asc_EQ(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_BSEARCH_ASC_EQ(data, l, r, value, return )
}

IndexT integer64_bsearch_asc_GE(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_BSEARCH_ASC_GE(data, l, r, value, return )
}

IndexT integer64_bsearch_asc_GT(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_BSEARCH_ASC_GT(data, l, r, value, return )
}

IndexT integer64_bsearch_asc_LE(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_BSEARCH_ASC_LE(data, l, r, value, return )
}

IndexT integer64_bsearch_asc_LT(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_BSEARCH_ASC_LT(data, l, r, value, return )
}


IndexT integer64_bsearch_desc_EQ(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_BSEARCH_DESC_EQ(data, l, r, value, return )
}

IndexT integer64_bsearch_desc_GE(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_BSEARCH_DESC_GE(data, l, r, value, return )
}

IndexT integer64_bsearch_desc_GT(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_BSEARCH_DESC_GT(data, l, r, value, return )
}

IndexT integer64_bsearch_desc_LE(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_BSEARCH_DESC_LE(data, l, r, value, return )
}

IndexT integer64_bsearch_desc_LT(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_BSEARCH_DESC_LT(data, l, r, value, return )
}



IndexT integer64_lsearch_asc_EQ(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_LSEARCH_ASC_EQ(data, l, r, value, return )
}

IndexT integer64_lsearch_asc_GE(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_LSEARCH_ASC_GE(data, l, r, value, return )
}

IndexT integer64_lsearch_asc_GT(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_LSEARCH_ASC_GT(data, l, r, value, return )
}

IndexT integer64_lsearch_asc_LE(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_LSEARCH_ASC_LE(data, l, r, value, return )
}

IndexT integer64_lsearch_asc_LT(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_LSEARCH_ASC_LT(data, l, r, value, return )
}


IndexT integer64_lsearch_desc_EQ(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_LSEARCH_DESC_EQ(data, l, r, value, return )
}

IndexT integer64_lsearch_desc_GE(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_LSEARCH_DESC_GE(data, l, r, value, return )
}

IndexT integer64_lsearch_desc_GT(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_LSEARCH_DESC_GT(data, l, r, value, return )
}

IndexT integer64_lsearch_desc_LE(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_LSEARCH_DESC_LE(data, l, r, value, return )
}

IndexT integer64_lsearch_desc_LT(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_LSEARCH_DESC_LT(data, l, r, value, return )
}



IndexT integer64_rsearch_asc_EQ(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_RSEARCH_ASC_EQ(data, l, r, value, return )
}

IndexT integer64_rsearch_asc_GE(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_RSEARCH_ASC_GE(data, l, r, value, return )
}

IndexT integer64_rsearch_asc_GT(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_RSEARCH_ASC_GT(data, l, r, value, return )
}

IndexT integer64_rsearch_asc_LE(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_RSEARCH_ASC_LE(data, l, r, value, return )
}

IndexT integer64_rsearch_asc_LT(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_RSEARCH_ASC_LT(data, l, r, value, return )
}


IndexT integer64_rsearch_desc_EQ(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_RSEARCH_DESC_EQ(data, l, r, value, return )
}

IndexT integer64_rsearch_desc_GE(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_RSEARCH_DESC_GE(data, l, r, value, return )
}

IndexT integer64_rsearch_desc_GT(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_RSEARCH_DESC_GT(data, l, r, value, return )
}

IndexT integer64_rsearch_desc_LE(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_RSEARCH_DESC_LE(data, l, r, value, return )
}

IndexT integer64_rsearch_desc_LT(ValueT *data, IndexT l, IndexT r, ValueT value){
  INTEGER64_RSEARCH_DESC_LT(data, l, r, value, return )
}




IndexT integer64_bosearch_asc_EQ(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_BOSEARCH_ASC_EQ(data, index, l, r, value, return)
}

IndexT integer64_bosearch_asc_GE(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_BOSEARCH_ASC_GE(data, index, l, r, value, return)
}

IndexT integer64_bosearch_asc_GT(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_BOSEARCH_ASC_GT(data, index, l, r, value, return)
}

IndexT integer64_bosearch_asc_LE(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_BOSEARCH_ASC_LE(data, index, l, r, value, return)
}

IndexT integer64_bosearch_asc_LT(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_BOSEARCH_ASC_LT(data, index, l, r, value, return)
}


IndexT integer64_bosearch_desc_EQ(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_BOSEARCH_DESC_EQ(data, index, l, r, value, return)
}

IndexT integer64_bosearch_desc_GE(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_BOSEARCH_DESC_GE(data, index, l, r, value, return)
}

IndexT integer64_bosearch_desc_GT(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_BOSEARCH_DESC_GT(data, index, l, r, value, return)
}

IndexT integer64_bosearch_desc_LE(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_BOSEARCH_DESC_LE(data, index, l, r, value, return)
}

IndexT integer64_bosearch_desc_LT(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_BOSEARCH_DESC_LT(data, index, l, r, value, return)
}



IndexT integer64_losearch_asc_EQ(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_LOSEARCH_ASC_EQ(data, index, l, r, value, return)
}

IndexT integer64_losearch_asc_GE(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_LOSEARCH_ASC_GE(data, index, l, r, value, return)
}

IndexT integer64_losearch_asc_GT(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_LOSEARCH_ASC_GT(data, index, l, r, value, return)
}

IndexT integer64_losearch_asc_LE(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_LOSEARCH_ASC_LE(data, index, l, r, value, return)
}

IndexT integer64_losearch_asc_LT(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_LOSEARCH_ASC_LT(data, index, l, r, value, return)
}


IndexT integer64_losearch_desc_EQ(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_LOSEARCH_DESC_EQ(data, index, l, r, value, return)
}

IndexT integer64_losearch_desc_GE(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_LOSEARCH_DESC_GE(data, index, l, r, value, return)
}

IndexT integer64_losearch_desc_GT(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_LOSEARCH_DESC_GT(data, index, l, r, value, return)
}

IndexT integer64_losearch_desc_LE(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_LOSEARCH_DESC_LE(data, index, l, r, value, return)
}

IndexT integer64_losearch_desc_LT(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_LOSEARCH_DESC_LT(data, index, l, r, value, return)
}



IndexT integer64_rosearch_asc_EQ(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_ROSEARCH_ASC_EQ(data, index, l, r, value, return)
}

IndexT integer64_rosearch_asc_GE(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_ROSEARCH_ASC_GE(data, index, l, r, value, return)
}

IndexT integer64_rosearch_asc_GT(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_ROSEARCH_ASC_GT(data, index, l, r, value, return)
}

IndexT integer64_rosearch_asc_LE(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_ROSEARCH_ASC_LE(data, index, l, r, value, return)
}

IndexT integer64_rosearch_asc_LT(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_ROSEARCH_ASC_LT(data, index, l, r, value, return)
}


IndexT integer64_rosearch_desc_EQ(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_ROSEARCH_DESC_EQ(data, index, l, r, value, return)
}

IndexT integer64_rosearch_desc_GE(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_ROSEARCH_DESC_GE(data, index, l, r, value, return)
}

IndexT integer64_rosearch_desc_GT(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_ROSEARCH_DESC_GT(data, index, l, r, value, return)
}

IndexT integer64_rosearch_desc_LE(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_ROSEARCH_DESC_LE(data, index, l, r, value, return)
}

IndexT integer64_rosearch_desc_LT(ValueT *data, IndexT *index, IndexT l, IndexT r, ValueT value){
  INTEGER64_ROSEARCH_DESC_LT(data, index, l, r, value, return)
}
